<template>
	<GridLayout class="input-area" rows="30, auto" marginBottom="5">
		<Label ref="label" row="1" :text="placeholder" opacity="0.4" fontSize="18" class="input" padding="10" />
		<TextView 
      ref="textView" 
      row="1" 
      padding="10" 
      :secure="secure" 
      :isEnabled="enabled" 
      :text="value" 
      @focus="onFocus" 
      @blur="onBlur" 
      @textChange="emitTextChange" 
    />
	</GridLayout>
</template>

<script>
import { Color } from "color";
export default {
  props: {
    placeholder: {
      type: String
    },
    secure: {
      type: String
    },
    value: {
      type: String,
      default: ""
    },
    enabled: {
      type: Boolean,
      default: true
    }
  },
  methods: {
    emitTextChange: function(event) {
      this.$emit("input", event.value);
    },
    onFocus: function() {
      // get our elments to maninpulate.
      const label = this.$refs.label.nativeView;
      const textView = this.$refs.textView.nativeView;

      // animate the label sliding up and less transparent.
      label
        .animate({
          translate: { x: 0, y: -40 },
          opacity: 1,
          color: new Color("#ffffff")
        })
        .then(() => {}, () => {});
      label.padding = 10;
      // set the border bottom color to green to indicate focus
      textView.borderBottomWidth = 3;
      // textView.animate({

      // })
      textView.borderBottomColor = new Color("#00b47e");
    },
    onBlur: function() {
      const label = this.$refs.label.nativeView;
      const textView = this.$refs.textView.nativeView;

      // if there is text in our input then don't move the label back to it's initial position.
      if (!textView.text) {
        label
          .animate({
            translate: { x: 0, y: 0 },
            opacity: 0.4,
            padding: 0,
            color: new Color("#ffffff")
          })
          .then(() => {}, () => {});
      }
      // reset border bottom color.
      textView.borderBottomWidth = 0;
    }
  }
};
</script>

<style>
label {
  color: #ffffff;
  z-index: 99px;
}
TextView {
  color: #ffffff;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.25);
  border-radius: 10px;
  background: #415eaa;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.25);
}
.input-area {
  margin: 50px;
}
</style>
